"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toESM = (mod, isNodeMode, target) => (target = mod != null ? __create(__getProtoOf(mod)) : {}, __copyProps(
  // If the importer is in node compatibility mode or this is not an ESM
  // file that has been converted to a CommonJS file using a Babel-
  // compatible transform (i.e. "__esModule" has not been set), then set
  // "default" to the CommonJS "module.exports" for node compatibility.
  isNodeMode || !mod || !mod.__esModule ? __defProp(target, "default", { value: mod, enumerable: true }) : target,
  mod
));
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// packages/babel/src/index.ts
var src_exports = {};
__export(src_exports, {
  macaronBabelPlugin: () => macaronBabelPlugin,
  macaronStyledComponentsPlugin: () => styledComponentsPlugin
});
module.exports = __toCommonJS(src_exports);

// packages/babel/src/transforms/callExpression.ts
var import_core2 = require("@babel/core");

// packages/babel/src/utils.ts
var import_core = require("@babel/core");
var import_helper_module_imports = require("@babel/helper-module-imports");
function registerImportMethod(path, name, moduleName = "@macaron-css/core") {
  const imports = path.scope.getProgramParent().macaronData.imports || (path.scope.getProgramParent().macaronData.imports = /* @__PURE__ */ new Map());
  if (!imports.has(`${moduleName}:${name}`)) {
    let id = (0, import_helper_module_imports.addNamed)(path, name, moduleName);
    imports.set(`${moduleName}:${name}`, id);
    return id;
  } else {
    let iden = imports.get(`${moduleName}:${name}`);
    return import_core.types.cloneNode(iden);
  }
}
function getNearestIdentifier(path) {
  let currentPath = path;
  while (currentPath.parentPath !== null) {
    if (currentPath.isIdentifier()) {
      return currentPath;
    }
    let id = currentPath.get("id");
    if (!Array.isArray(id)) {
      if (id.isIdentifier())
        return id;
      if (id.isArrayPattern()) {
        for (const el of id.get("elements")) {
          if (el.isIdentifier())
            return el;
        }
      }
    }
    let key = currentPath.get("key");
    if (!Array.isArray(key) && key.isIdentifier()) {
      return key;
    }
    currentPath = currentPath.parentPath;
  }
  return null;
}
var extractionAPIs = [
  // @macaron-css/core
  "macaron$",
  // @vanilla-extract/css
  "style",
  "styleVariants",
  "globalStyle",
  "createTheme",
  "createGlobalTheme",
  "createThemeContract",
  "createGlobalThemeContract",
  "assignVars",
  "createVar",
  "fallbackVar",
  "fontFace",
  "globalFontFace",
  "keyframes",
  "globalKeyframes",
  "style",
  "styleVariants",
  "globalStyle",
  "createTheme",
  "createGlobalTheme",
  "createThemeContract",
  "createGlobalThemeContract",
  "assignVars",
  "createVar",
  "fallbackVar",
  "fontFace",
  "globalFontFace",
  "keyframes",
  "globalKeyframes",
  // @vanilla-extract/recipes
  "recipe"
];

// packages/babel/src/transforms/callExpression.ts
function transformCallExpression(callPath, _callState) {
  const callee = callPath.get("callee");
  if (!extractionAPIs.some(
    (api) => callee.referencesImport("@macaron-css/core", api)
  )) {
    return;
  }
  const programParent = callPath.scope.getProgramParent();
  if (callPath.node.leadingComments?.some(
    (comment) => comment.value.trim() === "macaron-ignore"
  ) || callPath.parent?.leadingComments?.some(
    (comment) => comment.value.trim() === "macaron-ignore"
  )) {
    const bindings2 = getBindings(callPath.get("callee"));
    for (const binding of bindings2) {
      programParent.macaronData.nodes.push(findRootBinding(binding).node);
    }
    return;
  }
  const nearestIdentifier = getNearestIdentifier(callPath);
  const ident = nearestIdentifier ? programParent.generateUidIdentifier(
    `$macaron$$${nearestIdentifier.node.name}`
  ) : programParent.generateUidIdentifier("$macaron$$unknown");
  const importedIdent = registerImportMethod(
    callPath,
    ident.name,
    programParent.macaronData.cssFile
  );
  const bindings = getBindings(callPath);
  for (const binding of bindings) {
    programParent.macaronData.nodes.push(findRootBinding(binding).node);
  }
  programParent.macaronData.nodes.push(
    import_core2.types.exportNamedDeclaration(
      import_core2.types.variableDeclaration("var", [import_core2.types.variableDeclarator(ident, callPath.node)])
    )
  );
  programParent.macaronData.nodes.push(
    import_core2.types.variableDeclaration("var", [import_core2.types.variableDeclarator(importedIdent, ident)])
  );
  callPath.replaceWith(importedIdent);
}
function findRootBinding(path) {
  let rootPath;
  if (!("parent" in path) || path.parentPath?.isProgram()) {
    rootPath = path;
  } else {
    rootPath = path.parentPath;
  }
  return rootPath;
}
function getBindings(path) {
  const programParent = path.scope.getProgramParent();
  const bindings = [];
  path.traverse({
    Expression(expressionPath, state) {
      if (!expressionPath.isIdentifier())
        return;
      const binding = path.scope.getBinding(expressionPath);
      if (!binding || programParent.macaronData.bindings.includes(binding.path) || bindings.includes(binding.path))
        return;
      const rootBinding = findRootBinding(binding.path);
      if (path === rootBinding) {
        bindings.push(binding.path);
        return;
      }
      const bindingOfBindings = getBindings(rootBinding);
      bindings.push(...bindingOfBindings, binding.path);
    }
  });
  programParent.macaronData.bindings.push(...bindings);
  return bindings;
}

// packages/babel/src/transforms/postprocess.ts
var import_core3 = require("@babel/core");
var generator = __toESM(require("@babel/generator"));
function postprocess(path, state) {
  const programParent = path.scope;
  const cssExtract = generator.default(
    import_core3.types.program(programParent.macaronData.nodes)
  ).code;
  state.opts.result = [programParent.macaronData.cssFile, cssExtract];
}

// packages/babel/src/transforms/preprocess.ts
var import_hash = __toESM(require("@emotion/hash"));
function preprocess(path, state) {
  path.scope.macaronData = {
    imports: /* @__PURE__ */ new Map(),
    cssFile: `extracted_${(0, import_hash.default)(path.toString())}.css.ts`,
    nodes: [],
    bindings: []
  };
}

// packages/babel/src/styled.ts
var import_core4 = require("@babel/core");
function styledComponentsPlugin() {
  return {
    name: "macaron-css-babel:styled",
    visitor: {
      Program: {
        enter(path) {
          path.scope.macaronData ??= {};
          path.traverse({
            CallExpression(callPath) {
              const callee = callPath.get("callee");
              const isSolidAdapter = callee.referencesImport(
                "@macaron-css/solid",
                "styled"
              );
              const isReactAdapter = callee.referencesImport(
                "@macaron-css/react",
                "styled"
              );
              if (!isSolidAdapter && !isReactAdapter)
                return;
              const runtimeImport = isSolidAdapter ? "@macaron-css/solid/runtime" : "@macaron-css/react/runtime";
              const [tag, styles, ...args] = callPath.node.arguments;
              const styledIdent = registerImportMethod(
                callPath,
                "$$styled",
                runtimeImport
              );
              const recipeIdent = registerImportMethod(
                callPath,
                "recipe",
                "@macaron-css/core"
              );
              const recipeCallExpression = import_core4.types.callExpression(recipeIdent, [
                import_core4.types.cloneNode(styles)
              ]);
              import_core4.types.addComments(
                recipeCallExpression,
                "leading",
                callPath.node.leadingComments ?? []
              );
              const callExpression = import_core4.types.callExpression(styledIdent, [
                import_core4.types.cloneNode(tag),
                recipeCallExpression,
                ...args
              ]);
              import_core4.types.addComment(callExpression, "leading", " @__PURE__ ");
              callPath.replaceWith(callExpression);
              path.scope.crawl();
            }
          });
        }
      }
    }
  };
}

// packages/babel/src/index.ts
function macaronBabelPlugin() {
  return {
    name: "macaron-css-babel",
    visitor: {
      Program: {
        enter: preprocess,
        exit: postprocess
      },
      CallExpression: transformCallExpression
    }
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  macaronBabelPlugin,
  macaronStyledComponentsPlugin
});
//# sourceMappingURL=index.js.map